#pragma once

#include "memory.h"



/* A memory pool incrementally requesting new regions. */

class MemoryIncremental : public Memory
{
protected:
    unsigned int _limit;
    bool _limited;

public:
    explicit MemoryIncremental(unsigned int limit, offset_t region_size=PAGE_SIZE);

    explicit MemoryIncremental();

    virtual Region *region();

    virtual Region *region(offset_t size);

    virtual void release(Region *region);
};

// vim: tabstop=4 expandtab shiftwidth=4
